# ------------------------------------------------TIMER------------------------------------------------
# Flags fishing anything other than water (timer disabled if this is the case, see below).
execute as @e[type=fishing_bobber, limit=1] at @s unless block ~ ~-1 ~ water run tag @p add DirtBobber
execute as @a[nbt={Tags:["ActiveFT"]}] at @s unless entity @e[type=fishing_bobber, distance=..32] run tag @s add DirtBobber
execute as @e[type=fishing_bobber, limit=1] at @s if block ~ ~ ~ water run tag @p remove DirtBobber

# Starts the timer when a fishing rod is cast (see extra conditions below).
execute as @a[scores={cast_rod=1, fishtimer_started=0}, nbt={Tags:[ActiveFT]}] unless entity @s[nbt={Tags:["DirtBobber"]}] run function fishtimer:fishtimer_increment
execute as @a if score @s cast_rod matches 2.. run scoreboard players set @s cast_rod 1

# Stops the timer if neither hand holds a fishing rod or if the bobber isn't present (both conditions indicate an early reel-in).
execute as @a unless entity @s[nbt={SelectedItem:{id:"minecraft:fishing_rod"}}] unless entity @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:fishing_rod"}]}] run function fishtimer:objective_reset
execute as @a at @a unless entity @e[type=fishing_bobber, distance=..32] run function fishtimer:objective_reset

# Enables/disables the final time display based on the toggle status.
scoreboard players enable @a fishtimer_toggle
execute as @a if score @s fishtimer_toggle matches 1 run scoreboard players set @a fishtimer_toggle 4
execute as @a if score @s fishtimer_toggle matches 2 run function fishtimer:enable_fishtimer
execute as @a if score @s fishtimer_toggle matches 4 run function fishtimer:disable_fishtimer
execute as @a if score @s fishtimer_toggle matches 6.. run scoreboard players set @a fishtimer_toggle 2

# Transforms the _status.mcfunction_ function into a survival-friendly trigger.
scoreboard players enable @a fishtimer_status
execute if score @p fishtimer_status matches 1.. run function fishtimer:status



# ------------------------------------------------"ZEN FISHER" ADVANCEMENT------------------------------------------------
# Stores the current position of the player into temporary storage.
execute as @a store result score @s player_tempX run data get entity @s Pos[0] 1
execute as @a store result score @s player_tempY run data get entity @s Pos[1] 1
execute as @a store result score @s player_tempZ run data get entity @s Pos[2] 1

# Checks if the player has moved by comparing the previous position with the current position.
execute as @a[scores={moved=0}] unless score @s player_prevX = @s player_tempX run scoreboard players set @s moved 1
execute as @a[scores={moved=0}] unless score @s player_prevY = @s player_tempY run scoreboard players set @s moved 1
execute as @a[scores={moved=0}] unless score @s player_prevZ = @s player_tempZ run scoreboard players set @s moved 1

# If the player moved, resets the static_time timer to 0.
execute as @a[scores={moved=1}] run scoreboard players set @s static_time 0

# Increments the "static_time" timer if the player didn't move and a bobber is in water nearby (see the "DirtBobber" tag in the "TIMER" section above).
execute as @a[scores={moved=0}] if entity @e[type=fishing_bobber, distance=..32] unless entity @s[nbt={Tags:["DirtBobber"]}] run scoreboard players add @s static_time 1

# Executes a function if the player has stayed still for 10 minutes (12000 ticks).
execute as @a[scores={static_time=12000..}] run advancement grant @p only fishtimer:fished_in_one_spot

# Updates the previous position to match the current position for the next tick.
execute as @a store result score @s player_prevX run data get entity @s Pos[0] 1
execute as @a store result score @s player_prevY run data get entity @s Pos[1] 1
execute as @a store result score @s player_prevZ run data get entity @s Pos[2] 1

# Reset "moved" scoreboard to 0 for all players for the next tick.
execute as @a run scoreboard players set @s moved 0



# ------------------------------------------------ANCIENT NAUTILUS SHELL------------------------------------------------
# Gives the player effects (specified in  __shell_effect.mcfunction__) if they are IN WATER while transporting an Ancient Nautilus Shell (anywhere in inventory).
execute as @p[nbt={Inventory:[{id:"minecraft:nautilus_shell", components:{"minecraft:custom_data":{"tag": "NotRenamed"}}}]}] at @s if predicate minecraft:is_in_water run function fishtimer:shell_effect

# Gives a chance for nautilus shells held by drowned to upgrade to Ancient Nautilus Shells.
execute as @e[type=minecraft:drowned,nbt={HandItems:[{id:"minecraft:nautilus_shell"}]}] unless entity @s[nbt={Tags:["TriedShellUpgrade"]}] run function fishtimer:drowned_shell_upgrade

# Ensures a 100% drop rate for drowned holding Ancient Nautilus Shells.
execute as @e[type=minecraft:drowned, nbt={HandItems:[{id:"minecraft:nautilus_shell"}]}] run data merge entity @s {HandDropChances:[0f,1f]}



# ------------------------------------------------"OCEAN'S GIFT" ADVANCEMENT------------------------------------------------
# Tags items above water if the player holds a fishing rod. This essentially distinguishes between fished items and non-fishing obtained items.
execute as @e[type=item] at @s if block ~ ~-1 ~ water if entity @p[nbt={SelectedItem:{id:"minecraft:fishing_rod"}}] run data merge entity @s {Item:{components:{"minecraft:custom_data":{"tag":"FishingObtained"}}}}
execute as @e[type=item] at @s if block ~ ~-1 ~ water if entity @p[nbt={Inventory:[{Slot:-106b,id:"minecraft:fishing_rod"}]}] run data merge entity @s {Item:{components:{"minecraft:custom_data":{"tag":"FishingObtained"}}}}



# ------------------------------------------------"POSEIDON'S TRIDENT" ITEM------------------------------------------------
# Gives the player effects (specified in  __trident_effect.mcfunction__) if they are IN WATER and wield Poseidon's trident (mainhand or offhand).
execute as @p[nbt={Inventory:[{Slot:-106b,id:"minecraft:trident", components:{"minecraft:custom_data":{"tag":"PoseidonsTrident"}}}]}] if predicate minecraft:is_in_water run function fishtimer:trident_effect
execute as @p[nbt={SelectedItem:{id:"minecraft:trident", components:{"minecraft:custom_data":{"tag": "PoseidonsTrident"}}}}] if predicate minecraft:is_in_water run function fishtimer:trident_effect

# Ensures effects like regeneration haeve time to trigger before getting reapplied and thus reset.
execute as @p at @p unless predicate is_in_water run function fishtimer:stop_passive_regeneration
execute as @p[nbt=!{Inventory:[{id:"minecraft:nautilus_shell", components:{"minecraft:custom_data":{"tag": "NotRenamed"}}}]}] run function fishtimer:stop_passive_regeneration
execute as @p[nbt={Health:20.0f}] run function fishtimer:stop_passive_regeneration